// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI6LN4AO/samples/fsamp/main.h $
// $Rev: 53782 $
// $Date: 2023-09-28 12:54:28 -0500 (Thu, 28 Sep 2023) $

// 24DSI6LN4AO: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "24dsi6ln4ao_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)			(sizeof((a)) / sizeof((a)[0]))



// data types *****************************************************************

typedef struct
{
	// Application Settings

	s32	continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32	fsamp;			// The desired sample rate.
	s32	index;			// device index
	s32	minute_limit;	// for continuous testing
	s32	optimal;		// Limit computations to the optimal settings?
	int	qty;			// Number of devices detected.
	s32	range;			// Go from Fsamp min to max.
	s32	save;			// Save scan data to disk?
	s32	test_limit;		// for continuous testing

	int	fd;				// File descriptor for device to access.

	// Device Settings

} args_t;



// prototypes *****************************************************************

int	perform_tests(const args_t* args);



#endif
