// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/24DSI6LN4AO/utils/ao_ch_0_write.c $
// $Rev: 51458 $
// $Date: 2022-08-04 11:13:02 -0500 (Thu, 04 Aug 2022) $

// 24DSI6LN4AO: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	dsi6ln4ao_ao_ch_0_write
*
*	Purpose:
*
*		Provide a visual wrapper for the DSI6LN4AO_IOCTL_AO_CH_0_WRITE service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		The setting to apply.
*
*		get		The current setting is recorded here, if not NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int dsi6ln4ao_ao_ch_0_write(int fd, int index, int verbose, s32 set, s32* get)
{
	char	buf[128];
	int		errs;
	s32		ret;

	if (verbose)
		gsc_label_index("AO Channel 0 Write", index);

	ret		= dsi6ln4ao_ioctl(fd, DSI6LN4AO_IOCTL_AO_CH_0_WRITE, &set);
	errs	= ret ? 1 : 0;
	sprintf(buf, "0x%lX", (long) set);

	if (verbose)
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", buf);

	if (get)
		get[0]	= set;

	return(errs);
}


